# Copyright (c) 2007, Northwestern Medical Faculty Foundation, Inc.
# 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
# 
#   * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
#   * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 
#   * Neither the name of Northwestern Medical Faculty Foundation, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. 
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#Model for the folders table, which stores information about folders in the EDW.
#Has many report objects.
class ReportFolder < ActiveRecord::Base
  acts_as_tree
  has_many :reports

#Outputs the JavaScript code to generate a tree depicting the folder's structure with this folder as a root.
#For use with the Tigra Tree Menu JavaScript.
  def tree_output
    if self.children.to_s != "" || self.reports.to_s != ""
      @str_children = ""
      self.children.each { |s| @str_children << s.tree_output }
      self.reports.each { |s| @str_children << s.tree_output }
      return "[ '#{self == self.root ? 'Report Server' : self.report_folder_nm}', '/metarep/showReportFolder/#{self.id}', #{@str_children}],"
    else
      return ""
    end
  end	

#Generates the path of this object based on its physical location.
  def path
    if self.report_folder_nm == 'Reports'
      return "Reports"
    else
      return self.parent.path + "/" + self.report_folder_nm
    end
  end
end